package cn.iocoder.yudao.module.pms.service.iotdevicetemplateattrs;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;
import cn.iocoder.yudao.module.pms.controller.admin.iotdevicetemplateattrs.vo.IotDeviceTemplateAttrsPageReqVO;
import cn.iocoder.yudao.module.pms.controller.admin.iotdevicetemplateattrs.vo.IotDeviceTemplateAttrsSaveReqVO;
import cn.iocoder.yudao.module.pms.dal.dataobject.iotdevicetemplateattrs.IotDeviceTemplateAttrsDO;
import cn.iocoder.yudao.module.pms.dal.mysql.iotdevicetemplateattrs.IotDeviceTemplateAttrsMapper;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.pms.enums.ErrorCodeConstant.IOT_DEVICE_TEMPLATE_ATTRS_NOT_EXISTS;

/**
 * PMS 功能优化 设备模板属性 Service 实现类
 *
 * @author 芋道源码
 */
@Service
@Validated
public class IotDeviceTemplateAttrsServiceImpl implements IotDeviceTemplateAttrsService {

    @Resource
    private IotDeviceTemplateAttrsMapper iotDeviceTemplateAttrsMapper;

    @Override
    public Long createIotDeviceTemplateAttrs(IotDeviceTemplateAttrsSaveReqVO createReqVO) {
        // 插入
        IotDeviceTemplateAttrsDO iotDeviceTemplateAttrs = BeanUtils.toBean(createReqVO, IotDeviceTemplateAttrsDO.class);
        iotDeviceTemplateAttrsMapper.insert(iotDeviceTemplateAttrs);
        // 返回
        return iotDeviceTemplateAttrs.getId();
    }

    @Override
    public void updateIotDeviceTemplateAttrs(IotDeviceTemplateAttrsSaveReqVO updateReqVO) {
        // 校验存在
        validateIotDeviceTemplateAttrsExists(updateReqVO.getId());
        // 更新
        IotDeviceTemplateAttrsDO updateObj = BeanUtils.toBean(updateReqVO, IotDeviceTemplateAttrsDO.class);
        iotDeviceTemplateAttrsMapper.updateById(updateObj);
    }

    @Override
    public void deleteIotDeviceTemplateAttrs(Long id) {
        // 校验存在
        validateIotDeviceTemplateAttrsExists(id);
        // 删除
        iotDeviceTemplateAttrsMapper.deleteById(id);
    }

    private void validateIotDeviceTemplateAttrsExists(Long id) {
        if (iotDeviceTemplateAttrsMapper.selectById(id) == null) {
            throw exception(IOT_DEVICE_TEMPLATE_ATTRS_NOT_EXISTS);
        }
    }

    @Override
    public IotDeviceTemplateAttrsDO getIotDeviceTemplateAttrs(Long id) {
        return iotDeviceTemplateAttrsMapper.selectById(id);
    }

    @Override
    public PageResult<IotDeviceTemplateAttrsDO> getIotDeviceTemplateAttrsPage(IotDeviceTemplateAttrsPageReqVO pageReqVO) {
        return iotDeviceTemplateAttrsMapper.selectPage(pageReqVO);
    }

}